// Anforderung eines Helis zum Transport an einen Zielort, welcher ber
//  einen Klick auf die Karte bestimmt wird. [Vienna 14.08.2011]
//
// Aufrufbeispiel ber Aktionsmen: player addAction ["*** Helitransport anfordern ***", "myHeli\myHeli.sqf",[2],-1,false,true,""];
//      ...li.sqf",[2],-1,... die zwei steht fr die Anzahl der Wegpunkte auf der Karte!!           
//
// Verwendet Skripts: "myHeliInfo.sqf" und "myHeliWaypoints.sqf"

// lokale Variable
	private ["_clearAllWP","_addWP","_info","_t","_l","_h","_p","_wp","_s","_i","_maxWPs"];

//Anzahl der Wegpunkte
_maxWPs = (_this select 3)select 0;

//Funktion alle Wegpunkgte lschen. Aufurf: <Objekt> call _clearAllWP
	_clearAllWP = compile "private['_w'];for[{_w=Count Waypoints _this},{_w>=0},{_w=_w-1}]do{deleteWaypoint[group _this,_w]}";

//Funktion Wegpunkt hinzufgen. Aufruf: [<Objekt>,[<Position>],"Type"] call _addWP
	_addWP = compile "Private['_w'];_w=group(_this select 0)AddWaypoint[_this select 1,Count Waypoints (_this select 0)];_w SetWaypointType (_this select 2);_w ShowWaypoint'always';_w";

//globale Variable beim ersten Aufruf fr Bestimmung ob ein Heli aktiv ist.
	if (isNil "myHeliAktiv") then {myHeliAktiv = false};
	
//globale Variable Zielposition
	myHeliZielPosition = position player;

//Skript beenden falls bereits ein Heli akiv ist
	if(myHeliAktiv) exitWith {player groupChat "Es dauert noch etwas bis ein Heli bereit ist!"};

// globale Variable 
	myHeliAktiv = true;  // verhindert doppelte Anforderung des Helis

// _info: Textausgaben fr dieses Skript
	_info = [" -----> -----> -----> "];
	_info = _info + ["Heli im Anflug!"];
	_info = _info + ["Fliege zum Zielort!"];
	_info = _info + ["Abspringen oder warten bis Heli gelandet!"];
	_info = _info + ["Heli ist wieder bereit!"];
	_info = _info + ["Abflug zur Basis!"];
// _t: "Not-Ausstieg" nach ca. 3 Minuten "Leerlauf"
	_t = time + 180;
// _l: unsichtbares Lande H
	_l = "HeliHEmpty" createVehicleLocal myHeliZielPosition;
// _h: Heli
	_h = createVehicle ["Mi17_Civilian", myHeliZielPosition, [], 1000, "FLY"];
// _p: Pilot
	if (playerSide == WEST) then 
    {_p = createGroup WEST createUnit ["USMC_Soldier_Pilot", position _h, [], 0, "NONE"]}
	else
    {_p = createGroup EAST createUnit ["RU_Soldier_Pilot",   position _h, [], 0, "NONE"]};
  _p setSkill 1;
	_p setBehaviour "careless";
	_p setCombatMode "BLUE";
	_p allowFleeing 0;
	_p moveInDriver _h;

// Pilot fliegt zu Spieler
	player groupChat format["%1%2",_info select 0,_info select 1];
  _h setPos [getPos _h select 0,getPos _h select 1,25];
	_h flyinHeight 50;
	sleep 0.01;
	
//Skript fr Anzeige des Helistatus laden. 1.Aufruf
	[1,_h,_p] execVM "myHeli\myHeliInfo.sqf";
	
// _wp: fr Wegpunkthandhabung des Piloten
	_wp = group _p addWaypoint [myHeliZielPosition,0];
	[group _p, 0] SetWaypointType "move";
	group _p setCurrentWaypoint [group _p, 1];
	sleep 3;
	_h setspeedMode "full";
	
	sleep 5;
	_h flyinHeight 30;
 
// Warten bis Pilot beim Spieler eintrifft
	waitUntil {_h distance myHeliZielPosition < 200 OR time > _t};
	_h land "GET IN";

// Warten bis Spieler im Heli
	waitUntil {player in _h OR time > _t OR !(alive _p and _p IN _h)};
  _h land "NONE";
	if (time < _t and _p IN _h and alive _p) then 
		{
			// Warten bis Zielposition auf der Karte eingezeichnet
			ViennaMyHeliWP = 0;      // Fr Wegpunkte auf Karte setzen. 4 = Abflug
			myHeliZielPosition = []; // Beendet den 1. Aufruf von myHeliInfo.sqf 
			_maxWPs execVM "myHeli\myHeliWaypoints.sqf";  // Karte zum Eintragen der Wegpunkte aufrufen
			sleep 1;
			// Warten bis Zielort eingetragen
      waitUntil {ViennaMyHeliWP == 4 OR time > _t OR !visibleMap}; 
			// Kartenklick, Karte und Lande-H lschen
			onMapSingleClick "";
			openMap [false, false]; //Karte schlieen
			// Zielort anfliegen
			if (time < _t and ViennaMyHeliWP == 4) then //Abflug zum Zielort
				{
          _t=_t+120;//verlngern der "Not-Ausstiegzeit"
					player groupChat format["%1%2",_info select 0,_info select 2];
					//Pilot Heli hochziehen
					_h doMove getPos _h;
					_h flyinHeight 50;
					Sleep 2;
					//Wegpunkte vom Spieler (ohne Wegpunkt 0) auf den Piloten bertragen
					_p call _clearAllWP;
					for [{_i=0},{Count Waypoints player > _i+1},{_i=_i+1}] do {[_p,waypointPosition[group player, _i+1],"MOVE"] call _addWP};
					player call _clearAllWP;
					//Neues Ziel in Publikvariable
					myHeliZielPosition = waypointPosition[group _p,(Count Waypoints _p)-1];
          _l setPos myHeliZielPosition; //Lande-H auf Zielposition
					//Skript fr Anzeige des Helistatus laden. 2. Aufruf
					[2,_h,_p] execVM "myHeli\myHeliInfo.sqf";
					// Warten bis Heli beim Ziel eingetroffen
					waitUntil {_h distance myHeliZielPosition < 200 OR time > _t};
				  //Landung einleiten wenn noch "Ladung" im Heli
				  if (count crew _h > 1) then
            {
    					player groupChat format["%1%2",_info select 0,_info select 3];
              _t=_t+60;//verlngern der "Not-Ausstiegzeit"
              _h land "GET OUT";
              waitUntil {count crew _h < 2 OR time > _t};
    					//Pilot Heli hochziehen
              _h land "NONE";
    					_h doMove getPos _h;
    					_h flyinHeight 80;
    					Sleep 2
            }
				}
			else // Alle raus, Heli fliegt allein ins Abseits ab
				{
					{ if (_x != _p) then {_x action["Eject",_h]} } forEach crew _h
				}
		};
		
player groupChat format["%1%2",_info select 0,_info select 5];
	
//_s: Warten bis nchste Helianforderung mglich
	if (count crew _h > 1) then {_s = 100} else {_s = 40};
	if (_t-time < _s) then {_s = _t-time};
	if (_s < 1) then {_s = 1};

//Pilot im Heli?
	if (_p IN _h  and alive _p) then 
		{
			// Wenn wenn nur noch Pilot im Heli oder "Not-Ausstiegzeit" abgelaufen, dann Wegflug des Helis
			waitUntil {(count crew _h < 2) OR time > _t};
			//Pilot neuer Wegpunkt
			_wp = group _p addWaypoint [[0,0],Count Waypoints _p];
			[group _p, (Count Waypoints _p)-1] SetWaypointType "move";
			group _p setCurrentWaypoint [group _p,Count Waypoints _p];
			_h flyinHeight 100
		}
	else
		{
			//Wenn Pilot nicht im Heli, dann Heli flugunfhig setzen
			_h setDamage 0.8;
			if (_s > 31) then {_s = _s - 30};
			sleep 30
		};

// sind nach Zeitablauf noch mehr als der Pilot im Heli oder ist der Pilot tot oder nicht im Heli, dann wird der Heli jetzt zerstrt.
	if ((count crew _h > 1 AND time > _t) OR not alive _p OR not(_p IN _h)) then {_h setDamage 0.95; sleep _s; _s=1};

//Pilot alle Wegpunkte lschen; Piloten, Heli und Lande H entfernen 
	sleep 20;
	if (count crew _h == 0 AND time < _t AND _S > 1) then {sleep _s; _s=1};
	_p call _clearAllWP;
	deleteVehicle _h;
	deleteVehicle _p;
	deleteVehicle _l;

// neue Helianforderung mglich	
	sleep _s;
	if(myHeliAktiv) then {myHeliAktiv = false; player groupChat format["%1%2",_info select 0,_info select 4]}
